/***** bung zu Statistische Testverfahren / Ausgleichsrechnung II *****/
/*****  Jrg Schrder   Matr.Nr.: 155586   Guben, den 30.05.1996   *****/

/***** INCLUDES *****/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <float.h>
#include <C:\NET\SOURCE\geonet.h>  /* structuren */
#include <C:\NET\SOURCE\math_m2.c> /* functionen matrix*/
#include <C:\NET\SOURCE\file.c>    /* functionen file*/

/***** CONSTANTEN *****/
#define SYNTAX "\nGeoNet <project> [m0(apriori)] [Anz.d.Iterationen]\n        </h> Hilfe\n"
#define HILFE  "\nProgramm zur Ausgleichung von Lagenetzen\
\n\n[projekt]: Projektname, dieser sollte nur 8 Zeichen enthalten, die den\
\nKonventionen fr Dateinamen entsprechen.\
\nEine Eingabedatei '[project].in' wird im aktuellen Verzeichnis erwartet.\
\n\nJrg Schrder    Guben, den 30.05.1996\n"
#define RO (M_PI/200)

/***** MAIN *****/
int main(int argc, char *argv[])
	{
	/***** VARIABLEN *****/
	double *A,*P,*L,*X,*V,*Qxx,*R,*M,*NV,*GRZW,*GF,
			 m0_pri=0.02, m0_2_post,
			 nzp=4.13,
			 zw,
			 red,
			 probe, iprobe=1.,
			 q, k1, k2;

	char sbuf[255], pname[13];
	int a,
		 i, j,
		 f, n, fn, b, r, s, o,
		 fehler=0,
		 itera=0, iteramax=1,
		 err=0,warn=0;
	FILE *in, *out2, *out3;

	/***** ARGUMENTE ENTGEGENNEHMEN *****/
	if(argc < 2)
		{
		printf(SYNTAX);
		exit (1);
		}
	if(argc > 2)
		m0_pri=atof(argv[2]);
	if(argc > 3)
		{
		iteramax=atoi(argv[3]);
		}
	if(!strcmp(argv[1],"/?"))
		{
		printf(SYNTAX);                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */
	/* Anzahl der Elemente zhlen */
	f=0; n=0; s=0; r=0;
	while(!feof(in))
		{
		fgets(sbuf, 255, in);
		if (sbuf[0] != '*') a=atoi(sbuf); else a=0;
		switch (a)
			{
			case 1: f++; break;
			case 2: n++; break;
			case 3: r++; break;
			case 4: s++; break;
			}
		}
	rewind(in);
	/* Felder dimensionieren */
	p=malloc((n+f)*sizeof(_p));
	ri=malloc(r*sizeof(_ri));
	st=malloc(s*sizeof(_st));
	if(r>s) a=r; else a=s;
	sp_zp=malloc(a*2*sizeof(_sp_zp));
	ori=malloc(r/2*sizeof(_ori));
	fp=malloc(f*sizeof(int));
	np=malloc(n*sizeof(int));

	fn=0;r=0;s=0;
	while (!feof(in))
		{
		fgets(sbuf, 255, in);
		if (sbuf[0] != '*') a=atoi(sbuf); else a=0;
		switch (a)
			{
			case 1: sscanf(sbuf, "%i %li %lf %lf", &p[fn].bed,&p[fn].nr,&p[fn].x[0],&p[fn].x[1]); fn++; break;
			case 2: sscanf(sbuf, "%i %li %lf %lf", &p[fn].bed,&p[fn].nr,&p[fn].x[0],&p[fn].x[1]); fn++; break;
			case 3: sscanf(sbuf, "%i %li %li %lf %lf", &i,&sp_zp[r*2+0].sp,&sp_zp[r*2+0].zp,&ri[r].r,&ri[r].dr); r++; break;
			case 4: sscanf(sbuf, "%i %li %li %lf %lf", &i,&sp_zp[s*2+1].sp,&sp_zp[s*2+1].zp,&st[s].s,&st[s].ds); s++; break;
			}
		}
	/* Richtungen auf Radiant umrechnen */
	for(i=0; i<r; i++)
		{
		ri[i].r =ri[i].r * RO;
		ri[i].dr=ri[i].dr* RO;
		}
	/*Beobachtungen indexieren*/
	for(i=0; i<r; i++) beo_ind(i, 0, fn, &ri[i].is, &ri[i].iz);
	for(i=0; i<s; i++) beo_ind(i, 1, fn, &st[i].is, &st[i].iz);
	/*Orientierungen zhlen und indexieren*/
	o=ori_ind(r);
	/*Festpunkte und Neupunkte indexieren*/
	f=0; n=0;
	for(i=0; i<fn; i++)
		{
		if(p[i].bed==1) fp[f++]=i;
		if(p[i].bed==2) np[n++]=i;
		}
	b=r+s;
	n=n*2+o;
	free(sp_zp);

	/***** BERECHNUNGEN *****/
	/*Matrizen dimensionieren*/
	A=  malloc(b*n*sizeof(double));
	P=  malloc(b*  sizeof(double));
	L=  malloc(b*  sizeof(double));
	Qxx=malloc(n*n*sizeof(double));
	V  =malloc(b*  sizeof(double));
	X  =malloc(n*  sizeof(double));
	while((itera<iteramax)&&(iprobe>0.000001))
		{
		/*Aufstellen der Funktionalmatrix A*/
		for(i=0; i<s; i++)
			for(j=0; j<n-o; j++)
				A[i*n+j] = ds_dx(st[i].is, st[i].iz, j/2, j%2);
		for(i=0; i<r; i++)
			for(j=0; j<n-o; j++)
				A[(i+s)*n+j] = dr_dx(ri[i].is, ri[i].iz, j/2, j%2);
		for(i=0; i<s; i++)
			for(j=n-o; j<n; j++)
				A[i*n+j] = 0.;
		for(i=0; i<r; i++)
			for(j=n-o; j<n; j++)
				A[(i+s)*n+j]=  dr_do(ri[i].is, ri[ori[j-(n-o)].ir].is);
		/*Aufstellen der Gewichtsmatrix P*/
		for(i=0; i<b; i++)
			{
			if (i<s) P[i]=squ(m0_pri)/squ(st[i].ds);
			else     P[i]=squ(m0_pri)/squ(ri[i-s].dr);
			}
		/*Nherungswerte fr Orientierung*/
		for(i=0; i<o; i++)
			ori[i].o=rich(ri[ori[i].ir].is, ri[ori[i].ir].iz);
		/*Aufstellen der Fehlergleichung (L~)*/
		for(i=0; i<s; i++)
			L[i]=st[i].s-str(st[i].is,st[i].iz);
		for(i=0, j=0; i<r; i++)
			{
			if(ri[ori[j].ir].is != ri[i].is) j++;
			zw=rich(ri[i].is, ri[i].iz)-ori[j].o;
			if(zw<0.) zw+=2.*M_PI;
			L[i+s]=ri[i].r-zw;
			if(L[i+s]<-M_PI) L[i+s]+=2.*M_PI;
			}
		/*Normalgleichungsmatrix N*/
		AtPA(A, P, Qxx, b, n); 		/* N=AtPA 		*/
		inv(Qxx, n);               /* Qxx=N^-1		*/
		AtPL(A, P, L, V, b, n);    /* V=AtPL   (V dient hier nur als Zwischenspeicher)*/
		AB (Qxx, V, X, n, n, 1);	/* X=Qxx*(AtPL)*/
		/*Verbesserungen und Ausgleichsprobe*/
		AXmL(A, X, L, V, b, n);		/* V=AX-L      */
		probe=AtPV(A, P, V, b, n); /* probe=(AtPV)^2 */
		for(i=0; i<(n-o)/2; i++)   /* Verbesserungen anbringen */
			{
			p[np[i]].x[0]+=X[2*i];
			p[np[i]].x[1]+=X[2*i+1];
			}
		/*Empirische Varianz und mittlere Fehler der Unbekannten*/
		m0_2_post=VtPV(V, P, b)/(b-n); /* m0(apost)^2=VtPV/u */
		iprobe=squV(X,n);              /* Betrag der nderung der Nherungskoo.*/
		itera++;
		}
	free(L);
	/*Netzanalyse*/
	R=malloc(b*  sizeof(double));
	red=spurPQvv(A, Qxx, P, R, b, n);
	free(A);
	M=malloc(b*  sizeof(double));
	for(i=0; i<b; i++)
		M[i]=sqrt(m0_2_post)*sqrt(R[i]/P[i]);
	free(P);
	/*Normierte Verbesserung*/
	NV=malloc(b*  sizeof(double));
	for(i=0; i<b; i++)
				NV[i]=fabs(V[i])/M[i];
	/*Grenzwert fr nicht erkennbare Fehler*/
	GRZW=malloc(b*  sizeof(double));
	for(i=0; i<s; i++)
		GRZW[i]=(nzp*m0_pri)/sqrt(R[i]*(squ(m0_pri)/squ(st[i].ds)));
	for(i=s; i<b; i++)
		GRZW[i]=(nzp*m0_pri)/sqrt(R[i]*(squ(m0_pri)/squ(ri[i-s].dr)));
	/*Vermutliche Gre des Groben Fehlers*/
	GF=malloc(b*  sizeof(double));
	for(i=0; i<b; i++)
		GF[i]=-V[i]/R[i];
	/*Berechnung der Ellipsen*/
	ell=malloc((n-o)/2*sizeof(_ell));
	for(i=0; i<(n-o)/2; i++)
		{
		q=sqrt(squ(Qxx[(2*i+1)*n+(2*i+1)]-Qxx[2*i*n+2*i])+4*squ(Qxx[2*i*n+2*i+1]));
		k1=(Qxx[(2*i+1)*n+(2*i+1)]+Qxx[2*i*n+2*i]+q)/2.;
		k2=(Qxx[(2*i+1)*n+(2*i+1)]+Qxx[2*i*n+2*i]-q)/2.;
		ell[i].a=sqrt(m0_2_post*k1);
		ell[i].b=sqrt(m0_2_post*k2);
		ell[i].r=asin((k1-Qxx[(2*i+1)*n+(2*i+1)])/sqrt(squ(k1-Qxx[(2*i+1)*n+(2*i+1)])+squ(Qxx[2*i*n+2*i+1])));
		if(Qxx[2*i*n+2*i+1] < 0.) ell[i].r=-ell[i].r+2*M_PI;
		}
	/***** ERGEBNISDATEI SCHREIBEN *****/
	fprintf(out2, "*   Lage-Netzausgleichung nach vermittelnden Beobachtungen"
					"\n*   Projekt: %s ", pname);
	fprintf(out2, "\n*\n*   Festpunkte    : %i"
						  "\n*   Neupunkte     : %i"
						  "\n*   Strecken      : %i"
						  "\n*   Richtungen    : %i"
						  "\n*   Orientierungen: %i"
						  "\n*   Redundanz     : %i"
						  "\n*   Redundanz     : %-6.3lf (Kontrolle)"
						  "\n*   m0 (apriori)  : %6.4lf"
						  "\n*   m0 (apost)    : %6.4lf"
						  "\n*   AtPV^2        : %0.10lf"
						  "\n*   Iterationen   : %i"
						  ,f, (n-o)/2, s, r, o, b-n, red, m0_pri, sqrt(m0_2_post), probe, itera);

	fprintf(out2, "\n*\n*   Strecken"
						  "\n*   Standpk   Zielpk   s v AG   s n AG        v  m v AG   m n AG   EV   NV      GRZW        GF");
	j=0;
	for(i=0; i<s; i++)
		{
		fprintf(out2, "\n");
		if      (NV[i] > 3.3) {fprintf(out2, "!!"); fehler++;err++;}
		else if (NV[i] > 2.5) {fprintf(out2, "! "); fehler++;err++;}
		else if (R[i]  < .01) {fprintf(out2, "??"); fehler++;warn++;}
		else if (R[i]  < .1 ) {fprintf(out2, "? "); fehler++;warn++;}
		else 					     fprintf(out2, "4 ");
		fprintf(out2, " %8li %8li %8.3lf %8.3lf %8.3lf   %5.3lf %8.3lf %4.2lf %4.2lf  %8.3lf",
			p[st[i].is].nr, p[st[i].iz].nr, st[i].s, st[i].s+V[i], V[i],
			st[i].ds, M[i], R[i], NV[i], GRZW[i]);
		if(fehler > j) {fprintf(out2, " %9.3lf", GF[i]); j=fehler;}
		}
	fprintf(out2, "\n*   Richtungen"
					  "\n*   Standpk   Zielpk   r v AG   r n AG        v   m v AG   m n AG   EV   NV      GRZW        GF");
	for(i=0; i<r; i++)
		{
		fprintf(out2, "\n");
		if      (NV[i+s] > 3.3) {fprintf(out2, "!!"); fehler++;err++;}
		else if (NV[i+s] > 2.5) {fprintf(out2, "! "); fehler++;err++;}
		else if (R[i+s]  < .01) {fprintf(out2, "??"); fehler++;warn++;}
		else if (R[i+s]  < .1 ) {fprintf(out2, "? "); fehler++; warn++;}
		else 					     fprintf(out2, "3 ");
		fprintf(out2, " %8li %8li %8.4lf %8.4lf %8.4lf   %5.4lf %8.4lf %4.2lf %4.2lf  %8.4lf",
			p[ri[i].is].nr, p[ri[i].iz].nr, ri[i].r/RO, (ri[i].r+V[i+s])/RO, V[i+s]/RO,
			ri[i].dr/RO, M[i+s]/RO, R[i+s], NV[i+s], GRZW[i+s]/RO);
		if(fehler > j) {fprintf(out2, " %9.4lf", GF[i+s]/RO); j=fehler;}
		}
	fprintf(out2, "\n*   Orientierungen"
					  "\n*   Standpk   Zielpk   o v AG   o n AG   m n AG");
	for(i=0; i<o; i++)
		{
		if(ori[i].o < 0.) ori[i].o+=2.*M_PI;
		fprintf(out2, "\n5  %8li %8li %8.4lf %8.4lf %8.4lf",
			p[ri[ori[i].ir].is].nr, p[ri[ori[i].ir].iz].nr, ori[i].o/RO,
			(ori[i].o+X[n-o+i])/RO, sqrt(m0_2_post*Qxx[(n-o+i)*n+(n-o+i)])/RO);
		}
	fprintf(out2, "\n*   Neupunkte"
					  "\n*   Punktnr           y           x     my     mx      a      b       r");
	for(i=0; i<(n-o)/2; i++)
		{
		fprintf(out2, "\n2  %8li %11.3lf %11.3lf %6.3lf %6.3lf %6.3lf %6.3lf %7.3lf",
			p[np[i]].nr, p[np[i]].x[0], p[np[i]].x[1],
			sqrt(m0_2_post*Qxx[i*n+i]), sqrt(m0_2_post*Qxx[(i+1)*n+i+1]),
			ell[i].a, ell[i].b, ell[i].r/RO);
		}
	fprintf(out2, "\n*   Festpunkte"
					  "\n*   Punktnr           y           x");
	for(i=0; i<f; i++)
		fprintf(out2, "\n1  %8li %11.3lf %11.3lf",
			 p[fp[i]].nr, p[fp[i]].x[0], p[fp[i]].x[1]);
	fprintf(out2, "\n");

	/***** KOORDINATENDATEI SCHREIBEN *****/
	for(i=0; i<fn; i++)
		fprintf(out3, "%8li %11.3lf %11.3lf\n",p[i].nr, p[i].x[0],p[i].x[1]);

	/***** PROGRAMM BEENDEN *****/
	fclose(in);fclose(out2);fclose(out3);
	printf("\nFehler   : %i"
			 "\nWarnungen: %i", err, warn);
	printf("\n\nProgramm beendet!\n");
	return 0;
	}

